DOVEADM-FETCH(1)

NAME
doveadm-fetch - Fetch partial/full messages or message information

SYNOPSIS

doveadm [GLOBAL OPTIONS] [-f formatter] fetch [-S socket_path] -A fields search_query

doveadm [GLOBAL OPTIONS] [-f formatter] fetch [-S socket_path] -F file fields search_query

doveadm [GLOBAL OPTIONS] [-f formatter] fetch [-S socket_path] --no-userdb-lookup fields search_query

doveadm [GLOBAL OPTIONS] [-f formatter] fetch [-S socket_path] -u user fields search_query

DESCRIPTION

doveadm fetch can be used to fetch messages' contents and metadata. This can be useful for scripts and for debugging. If you want to fetch messages one at a time, see doveadm-search(1).

    •   Please respect your users' privacy.

GLOBAL OPTIONS

Global doveadm(1) options:

-D

        Enables verbosity and debug messages.

-O

        Do not read any config file, just use defaults. The dovecot_storage_version setting defaults to the latest version, but can be overridden with -o.

-k

        Preserve entire environment for doveadm, not just import_environment setting.

-v

        Enables verbosity, including progress counter.

-i instance-name

        If using multiple Dovecot instances, choose the config file based on this instance name.

        See instance_name setting for more information.

-c config-file

        Read configuration from the given config-file. By default it first reads config socket, and then falls back to /etc/dovecot/dovecot.conf. You can also point this to config socket of some instance running compatible version.

-o setting=value

        Overrides the configuration setting from /etc/dovecot/dovecot.conf and from the userdb with the given value. In order to override multiple settings, the -o option may be specified multiple times.

-f formatter

        Specifies the formatter for formatting the output. Supported formatters are:

        flow

            prints each line with key=value pairs.

json

    prints a JSON array of JSON objects.

pager

    prints each key: value pair on its own line and separates records with form feed character (^L).

tab

    prints a table header followed by tab separated value lines.

table

    prints a table header followed by adjusted value lines.

This command uses by default the output formatter pager.

OPTIONS

-A

        If the -A option is present, the command will be performed for all users. Using this option in combination with system users from userdb { driver = passwd } is not recommended, because it contains also users with a lower UID than the one configured with the first_valid_uid setting.

        When the SQL userdb module is used, make sure that the userdb_sql_iterate_query setting setting matches your database layout.

        When using the LDAP userdb module, make sure that the userdb_fields setting and userdb_ldap_iterate_fields setting settings match your LDAP schema. Otherwise doveadm(1) will be unable to iterate over all users.

-F file

        Execute the command for all the users in the file. This is similar to the -A option, but instead of getting the list of users from the userdb, they are read from the given file. The file contains one username per line.

--no-userdb-lookup

        Do not perform userdb lookup. Use the USER environment variable to specify the username.

-S socket_path

        The option's argument is either an absolute path to a local UNIX domain socket, or a hostname and port (hostname:port), in order to connect a remote host via a TCP socket.

        This allows an administrator to execute doveadm(1) mail commands through the given socket.

-u user/mask

        Run the command only for the given user. It's also possible to use '*' and '?' wildcards (e.g. -u *@example.org).

ARGUMENTS

fields

        One or more result field names to display, if the search_query matches any messages. In order to specify multiple fields, enclose them in single or double quotes.

        Supported fields are:

            binary : Message body in decoded format.

    binary.<section> : Part of the body decoded, e.g. binary.1

    body : The body of a message.

    body.<section> : Part of the body, e.g. body.1

    body.preview : Short preview of the body.

    body.snippet : Old alias for preview.

    date.received : Date and time of final delivery, when the message was delivered to a user's mailbox for the first time.

    The internal date and time of the source message, when the message was copied by the IMAP COPY command.

    The date-time attribute when present, otherwise the current time, when the message was saved by the IMAP APPEND command.

    date.received.unixtime : date.received as unix timestamp.

    date.saved : Date and time when the message was saved to mailbox.

    date.saved.unixtime : date.saved as unix timestamp.

    date.sent : Date and time of the message's Date: header.

    date.sent.unixtime : date.sent as unix timestamp.

    flags : A message's IMAP flags, e.g. \Seen

    guid : A message's globally unique identifier.

    hdr : The header of the message.

    hdr.<name> : Named header from the message.

    imap.body : IMAP BODY output of the message (see RFC 3501).

    imap.bodystructure : IMAP BODYSTRUCTURE output of the message (see RFC 3501).

    imap.envelope : IMAP ENVELOPE output of the message (see RFC 3501).

    mailbox : Name of the mailbox, in which the message is stored. The name is in UTF-8.

    mailbox-guid : The globally unique identifier of the mailbox, in which the message is located.

    modseq : Modification sequence number for the mail.

    pop3.order : A message's order number within a mailbox.

    pop3.uidl : A message's unique (POP3) identifier within a mailbox.

    refcount : Mail reference count, mdbox only.

    seq : A message's sequence number in a mailbox.

    size.physical : A message's physical size.

    size.virtual : A message's virtual size, computed with CRLF line terminators.

    storageid : Mailbox driver specific ID for the mail.

    text : The entire message (header and body).

    text.utf8 : The entire message (header and body) — UTF-8 encoded.

    uid : A message's unique (IMAP) identifier in a mailbox.

    user : A message owner's login name.

search_query

        Fetch messages matching this search query. See doveadm-search-query(1) for details.

EXAMPLE

This example based on the first example from doveadm-search(1). We are fetching the fields mailbox and date.sent from user bob's mailbox with the guid "3a94c928d66ebe4bda04000015811c6a" for the messages with the UIDs 8, 25 and 45.

    doveadm fetch -u bob "mailbox date.sent" mailbox-guid 3a94c928d66ebe4bda04000015811c6a uid 8,25,45

    mailbox: dovecot/pigeonhole/2.0
    date.sent: 2010-01-19 01:17:41 (+0100)
    ^L
    mailbox: dovecot/pigeonhole/2.0
    date.sent: 2010-01-28 09:38:49 (+0100)
    ^L
    mailbox: dovecot/pigeonhole/2.0
    date.sent: 2010-03-28 18:41:14 (+0200)

REPORTING BUGS

Report bugs, including doveconf -n output, to the Dovecot Mailing List ⟨dovecot@dovecot.org⟩. Information about reporting bugs is available at: ⟨https://dovecot.org/bugreport.html⟩

SEE ALSO

doveadm(1)